#include <stdio.h>
#include <dos.h>
int main()
{
  struct BIOS_EQUIP {
	unsigned bootdisk  : 1;
	unsigned copro     : 1;
	unsigned ram       : 2;
	unsigned video     : 2;
	unsigned fdd       : 2;
	unsigned dma       : 1;
	unsigned comport   : 3;
	unsigned gameio    : 1;
	unsigned s_prt     : 1;
	unsigned p_prt     : 2;
  } *equip;
  unsigned equipment;
  equipment = peek(0, 0x410);
  equip = (struct BIOS_EQUIP *)&equipment;
  printf("<< ROM BIOS DATA CHECKING >>\n");
  printf("Boot from disk = %u\n", equip->bootdisk);
  printf("Floating-point Coprocessor = %u\n", equip->copro);
  printf("Motherboard RAM size(kb)    = %u\n", (equip->ram+1)*16);
  printf("Initial VIDEO Mode = %u\n", equip->video);
  printf("Number of disk drives(FDD) = %u\n", equip->fdd);
  printf("Direct Memory Access(DMA) = %u\n", equip->dma);
  printf("Number of COM ports = %u\n", equip->comport);
  printf("Game I/O attached = %u\n", equip->gameio);
  printf("Serial Printer attached = %u\n", equip->s_prt);
  printf("Number of Parallel printers installed = %u\n", equip->p_prt);

  return 0;
}