#include <stdio.h>
#define UP	     0x48
#define DOWN     0x50
#define LEFT     0x4b
#define RIGHT    0x4d
int main()
{
  struct BIT_STREAM {
	unsigned b7: 1;
	unsigned b6: 1;
	unsigned b5: 1;
	unsigned b4: 1;
	unsigned b3: 1;
	unsigned b2: 1;
	unsigned b1: 1;
	unsigned b0: 1;
  };
  union KEYCODE {
	int no;
	char code[2];
	struct BIT_STREAM bits[2];
  } key;
  int i;
  printf("\nInput anykey...\n");
  while(!bioskey(1));
  key.no = bioskey(0);
  if (key.code[0])
  {
	printf("ASCII Code : %c\n", key.code[0]);
  } else {
	switch (key.code[1]) {
	  case UP: printf("Ext. Code : UP \n"); break;
	  case DOWN: printf("Ext. Code : DOWN \n"); break;
	  case LEFT: printf("Ext. Code : LEFT \n"); break;
	  case RIGHT: printf("Ext. Code : RIGHT \n"); break;
	}
  }
  printf("key.code[0] = %X, key.code[1] = %X\n", key.code[0], key.code[1]);
  printf("key.no = %X\n", key.no);
  for (i=1; i>=0; i--)
  {
	if (key.bits[i].b0) printf("1 ");
	else printf("0 ");
	if (key.bits[i].b1) printf("1 ");
	else printf("0 ");
	if (key.bits[i].b2) printf("1 ");
	else printf("0 ");
	if (key.bits[i].b3) printf("1 ");
	else printf("0 ");
	if (key.bits[i].b4) printf("1 ");
	else printf("0 ");
	if (key.bits[i].b5) printf("1 ");
	else printf("0 ");
	if (key.bits[i].b6) printf("1 ");
	else printf("0 ");
	if (key.bits[i].b7) printf("1 ");
	else printf("0 ");
  }
  printf("\n");

  return 0;
}