#include <stdio.h>
#define MAX_STACK_SIZE  10
#define FALSE 0
#define TRUE  1
typedef struct STACK {
  int stack[MAX_STACK_SIZE];
  int top;
} STACK;
int push(int data, STACK *s)
{
  if (s->top >= MAX_STACK_SIZE - 1)
  {
	printf("\nOOPs, Stack Overflow!!\n");
	return FALSE;
  }
  s->stack[++s->top] = data;
  return data;
}
int pop(STACK *s)
{
  if (s->top < 0) {
	printf("\nOOps, Stack Underflow!!\n");
	return FALSE;
  }
  return s->stack[s->top--];
}
int init_stack(STACK *s)
{
  if (!s) return FALSE;
  s->top = -1;
  return TRUE;
}
void print_stack(STACK *s)
{
  int i;
  for (i=s->top; i>=0; i--)
  {
	printf("stack[%d]|%8d|\n", i, s->stack[i]);
  }
}
int main()
{
  STACK s;
  init_stack(&s);
  printf("\nNow pushing data: 200, 300, 850\n\n");
  push(200, &s);
  push(300, &s);
  push(850, &s);
  print_stack(&s);
  printf("\npoping data: %d\n\n", pop(&s));
  print_stack(&s);
  printf("\npoping data: %d\n\n", pop(&s));
  print_stack(&s);
  printf("\npoping data: %d\n\n", pop(&s));
  print_stack(&s);
  pop(&s);
  return 0;
}